package _mains;

import javax.swing.UIManager;

import game.GameLoop;
import tools.Tools;
import tools.generated.Textures;
import tools.generators.ConfigGenerator;

/**
 * Point d'entrée de l'application
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0
 * 
 */
public class Main {

	private static Tools t;

	public static void main(String[] args) {
		// on set le look and feel
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e2) {
		}
		// on charge la config
		t = ConfigGenerator.ToolsInit();
		// chargement des images
		t.log("chargement des textures...");
		String error = null;
		error = Textures.start();
		if (error != null) {
			t.logError(error);
			System.exit(-1);
		}
		// on démmare la boucle de jeu
		GameLoop loop = new GameLoop();
		loop.start();
	}

}
