package game;

import java.awt.Color;
import java.awt.Image;

import game.objects.Button;
import tools.Tools;
import tools.generated.Textures;

/**
 * Constantes du jeu.
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0
 */

public interface Const {

	public final String ls = System.lineSeparator();
	public final boolean DEBUG = false;
	public final String VERSION = "1.0b";

	// resolution de la fenetre de jeu
	public final int W = 1280;
	public final int H = 720;

	// couleurs prédefinies
	public final Color RESET = new Color(0, 0, 100);
	public final Color TEXT = Color.BLACK;
	public final Color MASQUE = new Color(0, 0, 0, 80);
	public final Color NOCASH = new Color(250, 150, 50, 100);

	// constantes de jeux
	public final int INI_CASH = Tools.getInstance().getIntFor("INI_CASH");
	public final int MAX_LIFE = Tools.getInstance().getIntFor("MAX_LIFE");
	public final int SOMB_VALUE = Tools.getInstance().getIntFor("SOMB_VALUE");
	public final int SHOOT_DELAY = Tools.getInstance().getIntFor("SHOOT_DELAY");
	public final int PRICE_MUR = Tools.getInstance().getIntFor("PRICE_MUR");
	public final int PRICE_TOWER = Tools.getInstance().getIntFor("PRICE_TOWER");
	public final int PRICE_BARB = Tools.getInstance().getIntFor("PRICE_BARB");
	public final int PRICE_RELATION = Tools.getInstance().getIntFor("PRICE_RELATION");
	public final int PRICE_HUMMER = Tools.getInstance().getIntFor("PRICE_HUMMER");

	public final int POWER_TOWER = Tools.getInstance().getIntFor("POWER_TOWER");
	public final int POWER_BARB = Tools.getInstance().getIntFor("POWER_BARB");
	public final int POWER_HUMMER = Tools.getInstance().getIntFor("POWER_HUMMER");

	public final int ROUND_TOWER = Tools.getInstance().getIntFor("ROUND_TOWER");
	public final int ROUND_BARB = Tools.getInstance().getIntFor("ROUND_BARB");
	public final int ROUND_HUMMER = Tools.getInstance().getIntFor("ROUND_HUMMER");

	public final int RANGE_TOWER = Tools.getInstance().getIntFor("RANGE_TOWER");
	public final int RANGE_BARB = Tools.getInstance().getIntFor("RANGE_BARB");
	public final int RANGE_HUMMER = Tools.getInstance().getIntFor("RANGE_HUMMER");

	public final int PANIC = Tools.getInstance().getIntFor("PANIC");

	public final int INVASION_COST = 18;
	public final int MAX_INVA = 324;
	public final int INI_WAVE_DELAY = 120;

	public final int WALL_CHUCNK = 8;

	// etat de la boucle de jeu
	public final int PAUSE = -1;
	public final int INIT = 0;
	public final int INTRO = 1;
	public final int BRIEFING = 2;
	public final int PLAY = 3;
	public final int ENDGAME = 4;

	// dessin boutons
	public final int BT_MARGIN = 30;
	public final int BT_SIZE = 64;
	public final int BT_OFFSET = 270;
	public final int BT_GAP = 90;

	// on ne peut rien placer sur le terrain dans la partie interface ou dans le
	// ciel
	public final int AREA_TOP = 260;// ciel
	public final int AREA_LEFT = 200;// limite a gauche 'interface'
	public final int SPAWN_RANGE = 400;
	public final int WALL_SIZE = 56;

	// liste des boutons dispo
	public final static Button[] btList = { new Button(Textures.bt_cash, Const.PRICE_RELATION),
			new Button(Textures.bt_mur, Const.PRICE_MUR), new Button(Textures.bt_mirador, Const.PRICE_TOWER),
			new Button(Textures.bt_humvee, Const.PRICE_HUMMER), new Button(Textures.bt_barb, Const.PRICE_BARB) };

	public final int BT_RELATION_IDX = 0;
	public final int BT_MUR_IDX = 1;
	public final int BT_TOWER_IDX = 2;
	public final int BT_HUMMER_IDX = 3;
	public final int BT_BARB_IDX = 4;
	public final int BT_LAST_IDX = 5;

	// pays disponibles
	public final Image[][] map = {
			{ Textures.map_afrique1, Textures.map_ameriqueNord1, Textures.map_ameriqueSud1, Textures.map_antarctique1,
					Textures.map_asie1, Textures.map_europe1 },
			{ Textures.map_afrique2, Textures.map_ameriqueNord2, Textures.map_ameriqueSud2, Textures.map_antarctique2,
					Textures.map_asie2, Textures.map_europe2 },
			{ Textures.map_afrique3, Textures.map_ameriqueNord3, Textures.map_ameriqueSud3, Textures.map_antarctique3,
					Textures.map_asie3, Textures.map_europe3 } };
}
