package game.objects;

import engine.IRenderable;

/**
 * interface permetant l'inscription au rendu du moteur de jeu et l'interraction
 * avec l'environnement
 * 
 * @author Mikael GUILLEMOT
 *
 */
public interface ITower extends IRenderable {
	/**
	 * puissance de tir
	 */
	public int power();

	/**
	 * nombre de munitions par tour
	 */
	public int round();

	/**
	 * permet de definir si un enemis est a porté
	 */
	public boolean isInRange(int x, int y);

	/**
	 * renvoi la valeur de la tour
	 * 
	 * @return
	 */
	public int getCost();

}
