package game.objects;

import java.awt.Graphics2D;

import engine.IRenderable;
import game.Const;
import tools.generated.Textures;

/**
 * Gestion du mur, comme on autorise a placer les tours nimporte coment, on
 * automatise le placement du mur.
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0
 */

public class Mur implements IRenderable {

	int size = 0;

	public Mur() {
	}

	public void add() {
		size++;
	}

	public void reset() {
		size = 0;
	}

	public int getCost() {
		return Const.PRICE_MUR;
	}

	public int getsize() {
		return Const.AREA_TOP + size * Const.WALL_SIZE;
	}

	public boolean isCompleted() {
		return size >= Const.WALL_CHUCNK;
	}

	@Override
	public void render(Graphics2D image) {
		for (int i = 0; i < size; i++) {
			image.drawImage(Textures.obj_mur, Const.AREA_LEFT, Const.AREA_TOP + i * Const.WALL_SIZE, null);
		}
	}

}
