package game.objects;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;

import game.Const;
import tools.generated.Textures;
import engine.IRenderable;

public class Somb implements IRenderable {

	private Image anim[] = new Image[4];
	private Image animHit[] = new Image[4];
	private int time = 0, index = 0;
	public int x = Const.W, y = Const.AREA_TOP;
	private boolean active = true;
	private int value = Const.SOMB_VALUE;
	private int life = Const.MAX_LIFE;

	private int hit = 0;

	public Somb() {
		anim[0] = Textures.somb3;
		anim[1] = Textures.somb2;
		anim[2] = Textures.somb1;
		anim[3] = Textures.somb2;

		animHit[0] = Textures.sombhit3;
		animHit[1] = Textures.sombhit2;
		animHit[2] = Textures.sombhit1;
		animHit[3] = Textures.sombhit2;
		y += (int) (Math.random() * Const.SPAWN_RANGE);
		value += (int) (Math.random() * Const.SOMB_VALUE);
	}

	public boolean isAlive() {
		return life > 0;
	}

	public boolean isActive() {
		return active;
	}

	public void hit(int power) {
		life -= power;
		if (life <= 0)
			active = false;
		hit = 4;
	}

	public int getValue() {
		return value;
	}

	private void move() {
		time = 0;
		index++;
		x -= 4;
		if (x < 0) {
			active = false;
		}
	}

	@Override
	public void render(Graphics2D buffer) {
		if (active) {
			buffer.drawImage(hit > 0 ? animHit[index % 4] : anim[index % 4], x, y, null);
			time++;
			if (time > 3)
				move();

			if (Const.DEBUG) {
				buffer.setColor(Color.black);
				buffer.drawString(life + "pv", x + 50, y + 10);
				buffer.drawString(value + "$", x + 26, y - 2);
				if (Const.DEBUG) {
					buffer.setColor(Const.MASQUE);
					buffer.fillRect(x, y, 10, 10);
				}
			}
		}
		if (hit > 0)
			hit--;
	}

	public void kill() {
		life = 0;
		active = false;
	}

}
