package game.renderables;

import java.awt.Color;
import java.awt.Graphics2D;

import engine.IRenderable;
import game.Const;

/**
 * affichage de la couche visuelle d'interface
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0
 */

public class Selection implements IRenderable {

	private int x, y;

	public Selection() {
		this.x = Const.BT_MARGIN;
	}

	/**
	 * defini un rectangle de selection avec l'ofset en paramettre
	 * 
	 * @param offset
	 */
	public void setPosition(int actionIdx) {
		this.y = Const.BT_OFFSET + actionIdx * Const.BT_GAP;
	}

	/**
	 * desactive la selection
	 */
	public void reset() {
		this.y = 0;
	}

	@Override
	public void render(Graphics2D image) {

		if (y > 0) {
			image.setColor(new Color(0, 100, 200, 80));
			image.fillRect(x, y, 64, 64);
		}
	}

}
