package tools.generators;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;

import tools.Tools;
import tools.Tools.PropertiesGenerator;

/**
 * generateur de configuration
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0
 * @since
 * 
 */
public class ConfigGenerator implements PropertiesGenerator {

	private final static String ls = System.lineSeparator();

	/**
	 * methode statique d'initialisation des outils
	 * 
	 * @return un objet Tools initialisé avec le bon generateur ou le bon fichier de
	 *         config.
	 */
	public static Tools ToolsInit() {

		Tools.PropertiesGenerator pg = new ConfigGenerator();
		Tools._setPropertiesFile("./Data/The_wall.properties");
		Tools._setPropertiesGenerator(pg);
		return Tools.getInstance();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see tools.Tools.PropertiesGenerator#generate(java.lang.String)
	 */
	@Override
	public boolean generate(String fileName) {
		try {
			File f = new File(fileName);
			f.createNewFile();
			RandomAccessFile raf = new RandomAccessFile(f, "rw");
			raf.writeBytes("#default properties file for The WALL:" + ls);
			raf.writeBytes("#[general purpose keys]:" + ls);
			raf.writeBytes("LOG_ACTIVE = false" + ls);
			raf.writeBytes("TIMESTAMP_ACTIVE = false" + ls);
			raf.writeBytes("SILENT_LOG = false" + ls);
			raf.writeBytes("LOG_PATH = ./log/" + ls);
			raf.writeBytes("CLEAR_LOG = false" + ls);
			raf.writeBytes("PICTURE_PATH = ./data/" + ls);
			raf.writeBytes("" + ls);
			raf.writeBytes("#[game engine keys]:" + ls);
			raf.writeBytes("DISP_W = 1280" + ls);
			raf.writeBytes("DISP_H = 720" + ls);
			raf.writeBytes("ANTIALIASING = true" + ls);
			raf.close();
		} catch (IOException e) {
			return false;
		}
		return true;
	}

}
